#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Sink.h"

int Sink_ini(SDRB *p)
{
	if (!p) return 1;

	SDRB_set_data(p, NULL);

	return 0;
}

int Sink_run(SDRB *p)
{
	char c;

	if (!p) return 1;

	while (!SDRB_is_empty(p, 5))
	{
		SDRB_pop(p, 5, &c);
		putc(c, stdout);
	}

//	if (!SDRB_is_port_active(p, 5))
//		SDRB_set_running(p, FALSE);

	return 0;
}

int Sink_del(SDRB *p)
{
	if (!p) return 1;

	free(SDRB_get_data(p));
	return 0;
}

