#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Source.h"

int Source_ini(SDRB *p)
{
	if (!p) return 1;

	SDRB_set_data(p, malloc(sizeof(char)));

	*((char *) SDRB_get_data(p)) = 'Y';
	
	return 0;
}

int Source_rst(SDRB *p)
{
	if (!p) return 1;

	*((char *) SDRB_get_data(p)) = 'A';
	
	return 0;
}

int Source_run(SDRB *p)
{
	int i;
	char c;

	i = 0;

	if (SDRB_is_active(p))
	{
		c = *((char *) SDRB_get_data(p));
		if (!SDRB_is_full(p, 3))
		{
			SDRB_push(p, 3, &c);
			if ('Z' == c)
				SDRB_set_active(p, FALSE);
			else 
				*((char *) SDRB_get_data(p)) = c+1;
			i++;
		}
	}

	if (SDRB_is_active(p))
	{
		c = *((char *) SDRB_get_data(p));
		if (!SDRB_is_full(p, 3))
		{
			SDRB_push(p, 3, &c);
			if ('Z' == c)
				SDRB_set_active(p, FALSE);
			else 
				*((char *) SDRB_get_data(p)) = c+1;
			i++;
		}
	}

	printf(" |%1i| ", i);

	return 0;
}

int Source_del(SDRB *p)
{
	if (!p) return 1;

	free(SDRB_get_data(p));
	SDRB_set_data(p, NULL);

	return 0;
}

